## org.jgroups
Interface MembershipListener

All Known Subinterfaces:
  ExtendedMembershipListener, ExtendedReceiver, Receiver

All Known Implementing Classes:
  DistributedLockManager, DistributedQueue, DistributedTree, Draw, ExtendedReceiverAdapter, MembershipListenerAdapter, MyReceiver, NotificationBus, PartitionedHashMap, PartitionedHashMap.ArrayBasedConsistentHashFunction, PartitionedHashMap.ConsistentHashFunction, QuoteClient, QuoteServer, ReceiverAdapter, RELAY.Receiver, RelayDemoRpc, ReplCache, ReplicatedHashMap, ReplicatedTree, Topology, ViewDemo, VotingAdapter, Whiteboard

    public interface MembershipListener

Allows a listener to be notified when group membership changes. These callbacks are used in `PullPushAdapter`.

The MembershipListener interface is similar to the `MessageListener` interface: every time a new view, a suspicion message, or a block event is received, the corresponding method of the class implementing MembershipListener will be called. Oftentimes the only method containing any functionality will be viewAccepted() which notifies the receiver that a new member has joined the group or that an existing member has left or crashed.

Method Summary
`void` `block()` Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages.
`void` `suspect(Address suspected_mbr)` Called whenever a member is suspected of having crashed, but has not yet been excluded.
`void` `viewAccepted(View new_view)` Called when a change in membership has occurred.

Method Detail

### viewAccepted

    void viewAccepted(View new_view)

  Called when a change in membership has occurred. No long running actions or sending of messages should be done in this callback. If some long running action needs to be performed, it should be done in a separate thread.

  Note that on reception of the first view (a new member just joined), the channel will not yet be in the connected state. This only happens when `Channel.connect(String)` returns.

### suspect

    void suspect(Address suspected_mbr)

  Called whenever a member is suspected of having crashed, but has not yet been excluded.

### block

    void block()

  Called (usually by the FLUSH protocol), as an indication that the member should stop sending messages. Any messages sent after returning from this callback might get blocked by the FLUSH protocol. When the FLUSH protocol is done, and messages can be sent again, the FLUSH protocol will simply unblock all pending messages. If a callback for unblocking is desired, implement `ExtendedMembershipListener.unblock()`. Note that block() is the equivalent of reception of a BlockEvent in the pull mode.

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.